﻿using SabberStoneCore.Model.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SabberStoneCoreAi.src.Agent.Score
{
	class FatiqueScore : SabberStoneCoreAi.Score.Score
	{
		public override int Rate()
		{
			if (OpHeroHp < 1)
				return Int32.MaxValue;

			if (HeroHp < 1)
				return Int32.MinValue;

			float result = 0;

			if (OpBoardZone.Count == 0 && BoardZone.Count > 0)
				result += 1000;

			if (OpHandCnt > 9)
				result += 1000;

			if (OpDeckCnt == 0)
				result += 10000;

			result += (DeckCnt - OpDeckCnt) * CakeWinner.Weights.DeckWeight;

			result += (BoardZone.Count - OpBoardZone.Count) * CakeWinner.Weights.BoardZoneCountWeight;

			result += (MinionTotHealthTaunt - OpMinionTotHealthTaunt) * CakeWinner.Weights.MinionToHealthTauntWeight;

			result += MinionTotAtk;

			result += (HeroHp - OpHeroHp) * CakeWinner.Weights.HealthWeight;

			return (int)result;
		}

		public override Func<List<IPlayable>, List<int>> MulliganRule()
		{
			return p => p.Where(t => t.Cost > 3).Select(t => t.Id).ToList();
		}
		
	}
}
